
#property copyright "HS"
#property link      "http://futuresandforex.info/"

extern int           EA_magic          = 20100617;

extern double        GoShortNow        = 0;     // specify lot size, positions are then monitored with SAR rules
extern double        GoLongNow         = 0;
extern bool          stoptrading       = false; // reset to true if EA should continue running without taking new positions
extern bool          autolots          = false;
extern bool          dynamic_stops     = false;
extern bool          UseTrailingStop   = True;
extern double        TrailingStop      = 25;    // what is the optimum value for these?
extern double        scalp_sl          = 25;
extern double        scalp_tp          = 150;
extern double        slippage          = 2;
extern double        minLots           = 0.1;
extern double        maxLots           = 10;
extern double        Risk_percent      = 3;
extern int           TimeLimit         = 50;

int      numPos;
bool     Buy = false;
bool     Sell = false;
double   Lots, MyPoint, sl, tp, slip;
datetime LastSignal=0;
int      ticket;
double   SarStop, Direction, PrevDirection;

int init()
{
   MyPoint = Point;
   slip = slippage; // to avoid slippage being multiplied again with 10 if EA is reinitialized
   if(Digits == 5 || Digits == 3) {
      MyPoint = MyPoint*10;
      slip = slip*10;
   }
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   if( IsTradeAllowed() != true ){
      return(0);
   }
   
   SarStop = iCustom(NULL, 0, "myParabolic", 0.02, 0.2, 0, 0);
   SarStop = NormalizeDouble(SarStop, Digits);
   Direction = iCustom(NULL, 0, "myParabolic", 0.02, 0.2, 1, 0);
   PrevDirection = iCustom(NULL, 0, "myParabolic", 0.02, 0.2, 1, 1);
   
   Comment("SarStop = ",SarStop,", Direcxtion = ",Direction,", PrevDirection = ",PrevDirection); // for debugging

   count_position();
   if( numPos > 0){
      CheckForClose();
      SetTrailingStops();
   }
//   else
//   {
      if( LastSignal != Time[0] && stoptrading == false )
      {
         if( get_signal() == true )
         {
           SetStops();   // sets sl and tp
           Call_MM(sl);  // sets Lots
           if (Lots > 0)
           {
             if( Buy == true ) OpenLong(Lots);
             if( Sell == true ) OpenShort(Lots);
           }
           LastSignal = Time[0];
         }
      }
//   }
   
   // for use in live trading, these functions can't be used in back testing
   // they are triggered by resetting the EA properties with a lot size > 0
   // it is recommended to reset properties to 0 after the position is taken
   if( GoShortNow>0 ){
      SetStops();
      OpenShort(GoShortNow);
      GoShortNow = 0;
      LastSignal = Time[0];
   }
   
   if( GoLongNow>0 ){
      SetStops();
      OpenLong(GoLongNow);
      GoLongNow = 0;
      LastSignal = Time[0];
   }
   
   return(0);
}

void count_position()
{
    int ordticket;
    numPos  = 0;

    for( int i = 0 ; i < OrdersTotal() ; i++ ){
        if( OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) == false ){
            break;
        }
        if( OrderMagicNumber() != EA_magic ){
            continue;
        }
        if( OrderSymbol() != Symbol() ){
            continue;
        }
        ordticket = OrderTicket();
        numPos++;
    }
    if(numPos > 0) OrderSelect(ordticket, SELECT_BY_TICKET, MODE_TRADES);
}

bool get_signal()
{
    if( DayOfWeek()==5 && Hour()>=19 ) return(0);
    
    Buy = false;
    Sell = false;
    bool enable_trade = false;
      
    if( Bars >= 100 )
    {
      if (Direction>0 && PrevDirection<0 ){
      // what filter should I use NOT to buy?
         Buy=true;
      }
      
      if (Direction<0 && PrevDirection>0 ){
      // what filter should I use NOT to sell?
         Sell=true;
      }
   }
   if( Buy==true || Sell==true ) enable_trade = true;
   return(enable_trade);
}

void SetStops()
{
   if( dynamic_stops == true ){
      double range = 2*iATR(NULL, 0, 5, 1)/MyPoint;
      double ratio = scalp_sl/scalp_tp; // assume stoploss > profit target
      sl = NormalizeDouble(ratio*range, 0);
      tp = NormalizeDouble(range, 0);
   }
   else {
      sl = scalp_sl;
      tp = scalp_tp;
   }
   return(0);
}

void CheckForClose()
{
  if( OrdersTotal() > 0 )
  {
     if( (Time[TimeLimit]>=LastSignal || (DayOfWeek()==5 && Hour()>=20)) ) CloseAll();
     
     if (Direction>0 && PrevDirection<0 ) CloseShorts();
     
     if (Direction<0 && PrevDirection>0 ) CloseLongs();
  }
  return;
}

void CloseAll()
{
      int ordticket;
    
      for( int i = OrdersTotal()-1; i>=0; i-- ){
        if( OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) == false ){
            continue;
        }
        if( OrderMagicNumber() != EA_magic ){
            continue;
        }
        if( OrderSymbol() != Symbol() ){
            continue;
        }
        RefreshRates();
        ordticket = OrderTicket();
        if( OrderSelect(ordticket, SELECT_BY_TICKET, MODE_TRADES) == true ){
           OrderClose(ordticket,OrderLots(),Bid,slip+MarketInfo(Symbol(),MODE_SPREAD),White);
        } else {
           Print("CloseAll() returned an error: ",GetLastError());
        }
      }
   return;
}

void CloseShorts()
{
    int ordticket;
    
    for( int i = OrdersTotal()-1; i>=0; i-- ){
      if( OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) == false ){
         continue;
      }
      if( OrderMagicNumber() != EA_magic ){
          continue;
      }
      if( OrderSymbol() != Symbol() ){
          continue;
      }
      if( OrderType() != OP_SELL ){
          continue;
      }
      RefreshRates();
      ordticket = OrderTicket();
      if( OrderSelect(ordticket, SELECT_BY_TICKET, MODE_TRADES) == true ){
         OrderClose(ordticket,OrderLots(),Ask,slip,White);
      } else {
         Print("CloseShorts() returned an error: ",GetLastError());
      }
    }
    return;
}

void CloseLongs()
{
    int ordticket;
    
    for( int i = OrdersTotal()-1; i>=0; i-- ){
      if( OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) == false ){
         continue;
      }
      if( OrderMagicNumber() != EA_magic ){
          continue;
      }
      if( OrderSymbol() != Symbol() ){
          continue;
      }
      if( OrderType() != OP_BUY ){
          continue;
      }
      RefreshRates();
      ordticket = OrderTicket();
      if( OrderSelect(ordticket, SELECT_BY_TICKET, MODE_TRADES) == true ){
         OrderClose(ordticket,OrderLots(),Bid,slip,White);
      } else {
         Print("CloseLongs() returned an error: ",GetLastError());
      }
    }
    return;
}

void SetTrailingStops()
{
    if( !UseTrailingStop ) return;
    
    int ordticket;
    double stoploss;
    
    for( int i = OrdersTotal()-1; i>=0; i-- ){
      if( OrderSelect( i, SELECT_BY_POS, MODE_TRADES ) == false ){
         continue;
      }
      if( OrderMagicNumber() != EA_magic ){
          continue;
      }
      if( OrderSymbol() != Symbol() ){
          continue;
      }

      RefreshRates();
      ordticket = OrderTicket();
      if( OrderSelect(ordticket, SELECT_BY_TICKET, MODE_TRADES) == true ){
         if( TrailingStop > 0) {                 
            if(OrderType() == OP_BUY) {
               if( Direction > 0 && SarStop>Bid-MyPoint*TrailingStop ) {
                  stoploss = SarStop;
               } else {
                  stoploss = Bid-MyPoint*TrailingStop;
               }
                   
               if( OrderStopLoss() < stoploss ) {
                   OrderModify(ordticket, OrderOpenPrice(), stoploss, OrderTakeProfit(), 0, MediumSeaGreen);
                   continue;
               }
            } else {
               if( Direction < 0 && SarStop<Ask+MyPoint*TrailingStop ) {
                  stoploss = SarStop;
               } else {
                  stoploss = Ask+MyPoint*TrailingStop;
               }
               
               if( (OrderStopLoss()>stoploss) || (OrderStopLoss() == 0) ) {
                   if( OrderModify(ordticket, OrderOpenPrice(), stoploss, OrderTakeProfit(), 0, DarkOrange) == false )
                     Print("OrderModify() returned an error: ",GetLastError());
                   continue;
               }
            }
         }
      } else {
          Print("SetTrailingStops() returned an error: ",GetLastError());
      }
    }
    return;
}

int OpenLong(double volume=0.1)
{
  ticket = OrderSend( Symbol(), OP_BUY, volume, Ask, slip, 0, 0, "myLRCea", EA_magic, 0, Blue );
 
  if(ticket>0)
  {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
    {
       OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(sl*MyPoint),OrderOpenPrice()+(tp*MyPoint),0,CLR_NONE);
       return(0);
    }
    else
      {
        Print("OpenLong(),OrderSelect() - returned an error : ",GetLastError()); 
        return(-1);
      }   
  }
  else 
  {
    Print("Error opening Buy order : ",GetLastError()); 
    return(-1);
  }
}
  
int OpenShort(double volume=0.1)
{
  ticket = OrderSend( Symbol(), OP_SELL, volume, Bid, slip, 0, 0, "myLRCea", EA_magic, 0, Red );

  if(ticket>0)
  {
    if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
          OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(sl*MyPoint),OrderOpenPrice()-(tp*MyPoint),0,CLR_NONE);
          return(0);
      }
    else
      {
        Print("OpenShort(),OrderSelect() - returned an error: ",GetLastError()); 
        return(-1);
      }    
  }
  else 
  {
    Print("Error opening Sell order : ",GetLastError()); 
    return(-1);
  }
}

void Call_MM(double slpips)
{
   double riskcapital = AccountBalance()*Risk_percent/100;
   double tickvalue = (MarketInfo(Symbol(),MODE_TICKVALUE));

   if(Digits == 5 || Digits == 3){
      tickvalue = tickvalue*10;
   }
      
   if(slpips<=0) slpips=60;  // my arbitrary choice
   
   Lots=riskcapital/(slpips*tickvalue);

   if( Lots < 0.1 )          // is money enough for opening 0.1 lot?
      if( ( AccountFreeMarginCheck( Symbol(), OP_BUY,  0.1 ) < 10. ) || 
          ( AccountFreeMarginCheck( Symbol(), OP_SELL, 0.1 ) < 10. ) || 
          ( GetLastError() == 134 ) )
                  Lots = 0.0; // not enough
      else        Lots = 0.1; // enough; open 0.1
   else           Lots = NormalizeDouble( Lots, 2 ); 

   if( Lots>=0.1 && autolots==false ) Lots=MathMin(Lots, minLots);

   return;
}